<template>
  <el-dropdown placement="bottom" size="small" @command="handleChange">
    <el-button class="d2-mr btn-text can-hover" type="text">
      <d2-icon name="font" style="font-size: 16px;"/>
    </el-button>
    <el-dropdown-menu slot="dropdown">
      <el-dropdown-item v-for="item in sizeOptions" :key="item.value" :command="item.value">
        <d2-icon :name="iconName(item.value)" class="d2-mr-5"/>{{item.label}}
      </el-dropdown-item>
    </el-dropdown-menu>
  </el-dropdown>
</template>

<script>
import { mapState, mapActions } from 'vuex'
export default {
  name: 'd2-header-size',
  computed: {
    ...mapState('d2admin/size', [
      'value'
    ]),
    sizeOptions () {
      return [
        { label: this.$t('page.layout.size.default'), value: 'default' },
        { label: this.$t('page.layout.size.medium'), value: 'medium' },
        { label: this.$t('page.layout.size.small'), value: 'small' },
        { label: this.$t('page.layout.size.mini'), value: 'mini' }
      ]
    }
  },
  methods: {
    ...mapActions({
      sizeSet: 'd2admin/size/set'
    }),
    handleChange (value) {
      this.sizeSet(value)
      this.$notify({
        title: this.$t('page.layout.size.notification_title'),
        dangerouslyUseHTMLString: true,
        message: this.$t('page.layout.size.notification_message'),
        type: 'success'
      })
    },
    iconName (name) {
      return name === this.value ? 'dot-circle-o' : 'circle-o'
    }
  }
}
</script>
